[manpage_begin null n 2.2 memchan {Memory channels} {Create and manipulate null channels}]
[require Tcl]
[require memchan]
[description]
[para]
The command described here is only available in a not-yet released
version of the package. Use the CVS to get the sources.

[list_begin definitions]

[call [cmd null]]

creates a null channel which absorbes everything written into
it. Reading from it is not possible, or rather will always return zero
bytes. These channels are essentially Tcl-specific variants of the
null device for unixoid operating systems (/dev/null). Transfering the
generated channel between interpreters is possible but does not make
much sense.

[list_end]
[para]
Memory channels created by [cmd null] provide no additional options to
set or query.

[para]

A null channel is always writable and never readable. This means that a
writable [cmd fileevent]-handler will fire continuously and a readable
[cmd fileevent]-handler never at all. The exception to the latter is
only the destruction of the channel which will cause the delivery of
an eof event to a readable handler.

[see_also memchan fifo fifo2]
[keywords null {in-memory channel} channel i/o]
[manpage_end]
